chrome.runtime.sendMessage({
    type: "getGlobalStatus"
}, function(globalStatus) {
    if (globalStatus.enable) {
        window.addEventListener("message", function(event) {
            if (!event.data || typeof event.data.receiver == "undefined" || event.data.receiver != "AZcaptchaPlugin") {
                return
            }
            if (typeof event.data.type !== "undefined") {
                if (event.data.type == "solveRecaptcha" || event.data.type == "solveFuncaptcha") {
                    if (typeof event.data.containerSelector === "undefined" || !event.data.containerSelector) {
                        azCaptchaApiResponse(event.data.type, 3, 'Should specify a "containerSelector" field');
                        return
                    }
                    try {
                        if ($(event.data.containerSelector).length) {
                            if (globalStatus.account_key && globalStatus.account_key_checked || globalStatus.profile_user_info && globalStatus.free_attempts_left_count) {
                                if (event.data.type == "solveRecaptcha") {
                                    processGRecaptchaElement(event.data.containerSelector)
                                } else if (event.data.type == "solveFuncaptcha") {
                                    processFuncaptchaElement(event.data.containerSelector)
                                }
                                azCaptchaApiResponse(event.data.type, 0, "")
                            } else {
                                azCaptchaApiResponse(event.data.type, 2, "AZcaptcha.com account key not set or no free attempts left")
                            }
                        }
                    } catch (e) {
                        azCaptchaApiResponse(event.data.type, 4, "Invalid jQuery selector passed")
                    }
                } else if (event.data.type == "setImageCaptchaSelectors") {
                    if ((typeof event.data.imageSelector === "undefined" || !event.data.imageSelector && event.data.imageSelector !== null) && (typeof event.data.inputSelector === "undefined" || !event.data.inputSelector && event.data.inputSelector !== null)) {
                        azCaptchaApiResponse(event.data.type, 5, 'Should specify either an "imageSelector" or an "inputSelector" field or both');
                        return
                    }
                    var newCaptchaImageDeterminant;
                    var newCaptchaInputDeterminant;
                    var domain = null;
                    var saveInStorage = true;
                    if (typeof event.data.imageSelector !== "undefined" && (event.data.imageSelector || event.data.imageSelector === null)) {
                        if (event.data.imageSelector !== null) {
                            try {
                                $(event.data.imageSelector).length
                            } catch (e) {
                                azCaptchaApiResponse(event.data.type, 6, "Invalid jQuery imageSelector passed");
                                return
                            }
                        }
                        newCaptchaImageDeterminant = event.data.imageSelector
                    }
                    if (typeof event.data.inputSelector !== "undefined" && (event.data.inputSelector || event.data.inputSelector === null)) {
                        if (event.data.inputSelector !== null) {
                            try {
                                $(event.data.inputSelector).length
                            } catch (e) {
                                azCaptchaApiResponse(event.data.type, 7, "Invalid jQuery inputSelector passed");
                                return
                            }
                        }
                        newCaptchaInputDeterminant = event.data.inputSelector
                    }
                    if (typeof event.data.domain !== "undefined" && event.data.domain) {
                        try {
                            var domainParsed = parseUrl("http://" + event.data.domain)
                        } catch (e) {
                            azCaptchaApiResponse(event.data.type, 8, "Invalid domain passed");
                            return
                        }
                        if ((domainParsed.hostname == "http" || domainParsed.hostname == "https") && domainParsed.pathname != "/") {
                            azCaptchaApiResponse(event.data.type, 8, "Invalid domain passed, please provide a domain without HTTP/HTTPS protocol");
                            return
                        }
                        domain = domainParsed.hostname
                    }
                    if (typeof event.data.saveInStorage !== "undefined" && typeof event.data.saveInStorage === "boolean") {
                        saveInStorage = event.data.saveInStorage
                    }
                    setCaptchaDeterminantsForDomainGlobal(newCaptchaImageDeterminant, newCaptchaInputDeterminant, domain, saveInStorage, function(err, data) {
                        if (err) {
                            azCaptchaApiResponse(event.data.type, 9, err.message)
                        } else {
                            azCaptchaApiResponse(event.data.type, 0, "Image captcha selectors" + (domain ? " for a domain " + domain : "") + " are set")
                        }
                    })
                } else if (event.data.type == "setOptions") {
                    if (typeof event.data.options === "undefined") {
                        azCaptchaApiResponse(event.data.type, 11, 'Should specify an "options" object');
                        return
                    }
                    var incomingOptions = event.data.options;
                    var filteredOptions = {};
                    if (typeof incomingOptions.enable === "boolean") {
                        filteredOptions.enable = incomingOptions.enable
                    }
                    if (typeof incomingOptions.azCaptchaApiKey === "string") {
                        filteredOptions.account_key = incomingOptions.azCaptchaApiKey
                    }
                    if (typeof incomingOptions.autoSubmitForm === "boolean") {
                        filteredOptions.auto_submit_form = incomingOptions.autoSubmitForm
                    }
                    if (typeof incomingOptions.playSounds === "boolean") {
                        filteredOptions.play_sounds = incomingOptions.playSounds
                    }
                    if (typeof incomingOptions.useRecaptchaPrecaching === "boolean") {
                        filteredOptions.use_recaptcha_precaching = incomingOptions.useRecaptchaPrecaching
                    }
                    if (typeof incomingOptions.kPrecachedSolutionCountMin === "number") {
                        filteredOptions.k_precached_solution_count_min = incomingOptions.kPrecachedSolutionCountMin
                    }
                    if (typeof incomingOptions.kPrecachedSolutionCountMax === "number") {
                        filteredOptions.k_precached_solution_count_max = incomingOptions.kPrecachedSolutionCountMax
                    }
                    if (typeof incomingOptions.solveRecaptcha2 === "boolean") {
                        filteredOptions.solve_recaptcha2 = incomingOptions.solveRecaptcha2
                    }
                    if (typeof incomingOptions.dontReuseRecaptchaSolution === "boolean") {
                        filteredOptions.dont_reuse_recaptcha_solution = incomingOptions.dontReuseRecaptchaSolution
                    }
                    if (typeof incomingOptions.solveFuncaptcha === "boolean") {
                        filteredOptions.solve_funcaptcha = incomingOptions.solveFuncaptcha
                    }
                    if (typeof incomingOptions.startRecaptcha2SolvingWhenChallengeShown === "boolean") {
                        filteredOptions.start_recaptcha2_solving_when_challenge_shown = incomingOptions.startRecaptcha2SolvingWhenChallengeShown
                    }
                    if (typeof incomingOptions.solveOnlyPresentedRecaptcha2 === "boolean") {
                        filteredOptions.solve_only_presented_recaptcha2 = incomingOptions.solveOnlyPresentedRecaptcha2
                    }
                    if (typeof incomingOptions.usePredefinedImageCaptchaMarks === "boolean") {
                        filteredOptions.use_predefined_image_captcha_marks = incomingOptions.usePredefinedImageCaptchaMarks
                    }
                    if (typeof incomingOptions.reenableContextmenu === "boolean") {
                        filteredOptions.reenable_contextmenu = incomingOptions.reenableContextmenu
                    }
                    chrome.runtime.sendMessage({
                        type: "saveOptions",
                        options: filteredOptions
                    }, function(processedOptions) {
                        azCaptchaApiResponse(event.data.type, 0, "Options are set")
                    })
                } else {
                    azCaptchaApiResponse("", 10, 'Unknown "type" field passed')
                }
            } else {
                azCaptchaApiResponse("", 1, 'Should specify a "type" field')
            }
        })
    }
});