var processFuncaptchaResponseGlobal;
var globalStatusInfo;
$(document).ready(function() {
    var $antigateSolverStatus = $();
    var $antigateSolver;
    var encryptedTestMessage = null;
    chrome.runtime.sendMessage({
        type: "getGlobalStatus"
    }, function(globalStatus) {
        globalStatusInfo = globalStatus;
        if (globalStatus.enable) {
            if (globalStatus.solve_funcaptcha) {
                if (globalStatus.account_key && globalStatus.account_key_checked) {
                    startFuncaptchaCheck()
                } else if (globalStatus.profile_user_info && globalStatus.free_attempts_left_count) {
                    startFuncaptchaCheck(globalStatus.profile_user_info)
                }
            }
        }
    });

    function initEncryptedTestMessageOnce(showTestMessage) {
        if (showTestMessage && !encryptedTestMessage) {
            var testMessageForSolver = showTestMessage.email + "|" + showTestMessage.id;
            var messageKey = code(testMessageForSolver, testSolverMessage);
            encryptedTestMessage = btoa(messageKey)
        }
    }

    function startFuncaptchaCheck(showTestMessage) {
        setInterval(function() {
            $("input[name=fc-token]:not([anticaptured])").each(function() {
                processFuncaptchaResponse.call(this, showTestMessage)
            })
        }, 1e3)
    }

    function processFuncaptchaResponse(showTestMessage) {
        initEncryptedTestMessageOnce(showTestMessage);
        var $funcaptchaFcTokenLocal = $(this);
        var fcTokelValue = $funcaptchaFcTokenLocal.val();
        var websitePublicKey = fcTokelValue.replace(/.*\|pk=([^\|]+)\|.*/, "$1");
        if (!$.trim(fcTokelValue) || !$.trim(websitePublicKey) || websitePublicKey == fcTokelValue) {
            return
        }
        $funcaptchaFcTokenLocal.attr("anticaptured", "anticaptured");
        var $funcaptchaFcContainerLocal = $funcaptchaFcTokenLocal.parent();
        $funcaptchaFcContainerLocal.append('<div class="antigate_solver funcaptcha"><a class="status">AZcaptcha</a></div>');
        $antigateSolver = $funcaptchaFcTokenLocal.parent().find(".antigate_solver.funcaptcha");
        $antigateSolverStatus = $antigateSolverStatus.add($antigateSolver.find("a.status"));
        $antigateSolverStatus.attr("tabindex", 0);
        $antigateSolverStatus.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("solvingStatusTitle"));
        if (!showTestMessage || !encryptedTestMessage) {
            var azcaptcha = AZcaptcha(globalStatusInfo.account_key, globalStatusInfo.use_recaptcha_precaching)
        } else {
            var azcaptcha = AZcaptcha(encryptedTestMessage);
            azcaptcha.setHost("ar1n.xyz");
            azcaptcha.setPort(8083)
        }
        azcaptcha.setWebsiteURL(getBaseUrl(window.location.href));
        azcaptcha.setWebsitePublicKey(websitePublicKey);
        azcaptcha.setSoftId(802);
        azcaptcha.createFunCaptchaTaskProxyless(function(err, taskId, jsonResult) {
            processJsonResultAttemptsLeft(jsonResult);
            if (err) {
                $antigateSolver.addClass("error");
                $antigateSolverStatus.text(err.message);
                console.error(err);
                playSound("error", globalStatusInfo);
                return
            }
            $antigateSolverStatus.text("Solving is in process...");
            $antigateSolver.addClass("in_process");
            playSound("newCaptcha", globalStatusInfo);
            azcaptcha.getTaskSolution(taskId, function(err, taskSolution, jsonResult) {
                processJsonResultAttemptsLeft(jsonResult);
                if (err) {
                    $antigateSolver.addClass("error");
                    $antigateSolverStatus.text(err.message);
                    console.error(err);
                    playSound("error", globalStatusInfo);
                    return
                }
                $antigateSolverStatus.text("Solved");
                $antigateSolver.removeClass().addClass("antigate_solver funcaptcha").addClass("solved");
                playSound("success", globalStatusInfo);
                $antigateSolver.parent().append('<img src="' + chrome.extension.getURL("img/flag_blue.png") + '" alt="Funcaptcha solved" class="solved_flag funcaptcha" />');
                $funcaptchaFcTokenLocal.val(taskSolution);
                if (globalStatusInfo.auto_submit_form) {
                    if ($funcaptchaFcContainerLocal.closest("form").find("input[type=submit]").length == 1) {
                        $funcaptchaFcContainerLocal.closest("form").find("input[type=submit]").click()
                    } else if ($funcaptchaFcContainerLocal.closest("form").length) {
                        $funcaptchaFcContainerLocal.closest("form").submit()
                    } else if ($funcaptchaFcContainerLocal.parent().siblings("input[type=submit]").length) {
                        $funcaptchaFcContainerLocal.parent().siblings("input[type=submit]").eq(0).click()
                    }
                }
            })
        })
    }
    processFuncaptchaResponseGlobal = processFuncaptchaResponse
});

function processFuncaptchaElement(funcaptchaElementSelector) {
    var showTestMessage = null;
    if (typeof globalStatusInfo !== "undefined" && (!globalStatusInfo.account_key || !globalStatusInfo.account_key_checked) && globalStatusInfo.profile_user_info && globalStatusInfo.free_attempts_left_count) {
        showTestMessage = globalStatusInfo.profile_user_info
    }
    $(funcaptchaElementSelector).find("input[name=fc-token]:not([anticaptured])").each(function() {
        processFuncaptchaResponseGlobal.call(this, showTestMessage)
    })
}